Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.Designer.cs	(revision 15606)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.Designer.cs	(revision 15607)
@@ -54,4 +54,5 @@
       this.yAxisComboBox = new System.Windows.Forms.ComboBox();
       this.chart = new HeuristicLab.Visualization.ChartControlsExtensions.EnhancedChart();
+      this.openBubbleChartViewToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.noRunsLabel = new System.Windows.Forms.Label();
       this.splitContainer = new System.Windows.Forms.SplitContainer();
@@ -112,6 +113,6 @@
       // chart
       // 
-      this.chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       chartArea1.Name = "ChartArea1";
@@ -132,4 +133,11 @@
       this.chart.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove);
       // 
+      // openBubbleChartViewToolStripMenuItem
+      // 
+      this.openBubbleChartViewToolStripMenuItem.Name = "openBubbleChartViewToolStripMenuItem";
+      this.openBubbleChartViewToolStripMenuItem.Size = new System.Drawing.Size(256, 22);
+      this.openBubbleChartViewToolStripMenuItem.Text = "Open BubbleChart View";
+      this.openBubbleChartViewToolStripMenuItem.Click += new System.EventHandler(this.openBubbleChartViewToolStripMenuItem_Click);
+      // 
       // noRunsLabel
       // 
@@ -183,6 +191,6 @@
       // statisticsGroupBox
       // 
-      this.statisticsGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.statisticsGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.statisticsGroupBox.Controls.Add(this.statisticsMatrixView);
@@ -239,4 +247,5 @@
     private System.Windows.Forms.ToolTip tooltip;
     protected System.Windows.Forms.CheckBox showStatisticsCheckBox;
+    private System.Windows.Forms.ToolStripMenuItem openBubbleChartViewToolStripMenuItem;
   }
 }
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.cs	(revision 15606)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.cs	(revision 15607)
@@ -48,4 +48,6 @@
     public RunCollectionBoxPlotView() {
       InitializeComponent();
+      chart.ContextMenuStrip.Items.Insert(0, openBubbleChartViewToolStripMenuItem);
+
       categoricalMapping = new Dictionary<int, Dictionary<object, double>>();
       seriesCache = new SortedDictionary<double, Series>();
@@ -224,5 +226,6 @@
             AxisDimension axisDimension = (AxisDimension)Enum.Parse(typeof(AxisDimension), selectedAxis);
             switch (axisDimension) {
-              case AxisDimension.Color: value = new StringValue(run.Color.ToString());
+              case AxisDimension.Color:
+                value = new StringValue(run.Color.ToString());
                 break;
             }
@@ -445,4 +448,12 @@
     }
 
+    private void openBubbleChartViewToolStripMenuItem_Click(object sender, EventArgs e) {
+      RunCollectionBubbleChartView bubbleChartView = new RunCollectionBubbleChartView();
+      bubbleChartView.Content = this.Content;
+      bubbleChartView.xAxisComboBox.SelectedItem = xAxisComboBox.SelectedItem;
+      bubbleChartView.yAxisComboBox.SelectedItem = yAxisComboBox.SelectedItem;
+      bubbleChartView.Show();
+    }
+
     private void chart_MouseMove(object sender, MouseEventArgs e) {
       string newTooltipText = string.Empty;
@@ -463,9 +474,9 @@
     }
 
-	public bool StatisticsVisible {
-		get { return splitContainer.Panel2Collapsed; }
-		set { splitContainer.Panel2Collapsed = value; }
-	}
-	
+    public bool StatisticsVisible {
+      get { return splitContainer.Panel2Collapsed; }
+      set { splitContainer.Panel2Collapsed = value; }
+    }
+
     public void SetXAxis(string axisName) {
       xAxisComboBox.SelectedItem = axisName;
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.Designer.cs	(revision 15606)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.Designer.cs	(revision 15607)
@@ -201,6 +201,6 @@
       // chart
       // 
-      this.chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       chartArea1.Name = "ChartArea1";
@@ -455,7 +455,7 @@
 
     private System.Windows.Forms.Label xAxisLabel;
-    private System.Windows.Forms.ComboBox xAxisComboBox;
+    internal System.Windows.Forms.ComboBox xAxisComboBox;
     private System.Windows.Forms.Label yAxisLabel;
-    private System.Windows.Forms.ComboBox yAxisComboBox;
+    internal System.Windows.Forms.ComboBox yAxisComboBox;
     private System.Windows.Forms.TrackBar yTrackBar;
     private System.Windows.Forms.TrackBar xTrackBar;